diff --git a/emcc.py b/emcc.py
index ffa0c5cdc2f..8491adfa3c7 100755
--- a/emcc.py
+++ b/emcc.py
@@ -2654,8 +2654,48 @@ def generate_html(target, options, js_target, target_basename,
     script.src = None
     script.inline = js_contents
 
+  if shared.Settings.USE_PTHREADS and shared.Settings.PROXY_TO_PTHREAD:
+    get_char = '''
+        get_char: (function() {
+          var keys = '';
+          var output = document.getElementById('output');
+          output.focus();
+
+          output.addEventListener('keydown', function(ev) {
+            // Make sure cursor is at end of textarea
+            var len = output.value.length;
+            output.setSelectionRange(len, len);
+
+            var key = ev.keyCode || ev.which;
+            if (key == '\\r') key = key + '\\n';
+            if (ev.key == 'Backspace') {
+              // Backspace - erase the last character in Module.keys
+              if (keys == '') ev.preventDefault();
+              keys = keys.slice(0, -1);
+            }
+            else if (ev.code == 'Enter') {
+              keys += '\\r';
+              setTimeout(_emscripten_main_thread_process_queued_calls, 0);
+            }
+            else if ((ev.key.length == 1) && !ev.altKey && !ev.ctrlKey && !ev.metaKey){
+              keys += ev.key;
+            }
+          });
+          return function() {
+            if (keys === '') {
+              return undefined;
+            }
+            var k = keys;
+            keys = ''
+            return k;
+          };
+        })(),'''
+  else:
+    get_char = ''
+    
   html = open(target, 'wb')
   html_contents = shell.replace('{{{ SCRIPT }}}', script.replacement())
+  html_contents = html_contents.replace('{{{ GET_CHAR }}}', get_char)
   html_contents = tools.line_endings.convert_line_endings(html_contents, '\n', options.output_eol)
   html.write(asbytes(html_contents))
   html.close()
diff --git a/src/library_tty.js b/src/library_tty.js
index f3d70579d67..fce127e180b 100644
--- a/src/library_tty.js
+++ b/src/library_tty.js
@@ -63,6 +63,9 @@ mergeInto(LibraryManager.library, {
           if (result === null || result === undefined) break;
           bytesRead++;
           buffer[offset+i] = result;
+
+          // If EOL character, return having put it in the buffer.
+          if (result === 10) break;
         }
         if (bytesRead) {
           stream.node.timestamp = Date.now();
@@ -127,7 +130,8 @@ mergeInto(LibraryManager.library, {
             } else {
               result = null;
             }
-
+          } else if (Module['get_char'] != undefined) {
+	            result = Module['get_char']();
           } else if (typeof window != 'undefined' &&
             typeof window.prompt == 'function') {
             // Browser.
@@ -143,13 +147,19 @@ mergeInto(LibraryManager.library, {
             }
           }
           if (!result) {
-            return null;
+            return result;
           }
           tty.input = intArrayFromString(result, true);
         }
         return tty.input.shift();
       },
       put_char: function(tty, val) {
+        if (Module['rawPrint'] != undefined) {
+          if (val != 0) tty.output.push(val);
+          Module['rawPrint'](UTF8ArrayToString(tty.output, 0));
+          tty.output = [];
+          return;
+        }
         if (val === null || val === {{{ charCode('\n') }}}) {
           Module['print'](UTF8ArrayToString(tty.output, 0));
           tty.output = [];
@@ -166,6 +176,12 @@ mergeInto(LibraryManager.library, {
     },
     default_tty1_ops: {
       put_char: function(tty, val) {
+        if (Module['rawPrintErr'] != undefined) {
+          if (val != 0) tty.output.push(val);
+          Module['rawPrintErr'](UTF8ArrayToString(tty.output, 0));
+          tty.output = [];
+          return;
+        }
         if (val === null || val === {{{ charCode('\n') }}}) {
           Module['printErr'](UTF8ArrayToString(tty.output, 0));
           tty.output = [];
diff --git a/src/shell.html b/src/shell.html
index 7b494f1a7f0..436c6de11c7 100644
--- a/src/shell.html
+++ b/src/shell.html
@@ -1249,6 +1249,22 @@
             console.error(text);
           }
         },
+        rawPrint: function(text) {
+          var element = document.getElementById('output');
+          if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
+          if (text == "\n") {
+            text = "\r" + text;
+          }
+          element.value += text;
+        },
+        rawPrintErr: function(text) {
+          var element = document.getElementById('output');
+          if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
+          if (text == "\n") {
+            text = "\r" + text;
+          }
+          element.value += text;
+        },{{{ GET_CHAR }}}
         canvas: (function() {
           var canvas = document.getElementById('canvas');
 
diff --git a/src/shell.js b/src/shell.js
index bba2af9c52c..c3f5ed4b4c7 100644
--- a/src/shell.js
+++ b/src/shell.js
@@ -82,6 +82,8 @@ if (ENVIRONMENT_IS_NODE) {
   // Note that we pollute the global namespace here, otherwise we break in node
   if (!Module['print']) Module['print'] = console.log;
   if (!Module['printErr']) Module['printErr'] = console.warn;
+  if (!Module['rawPrint']) Module['rawPrint'] = function(txt) { process.stdout.write(txt); }
+  if (!Module['rawPrintErr']) Module['rawPrintErr'] = function(txt) { process.stderr.write(txt); }
 
   var nodeFS;
   var nodePath;
@@ -151,6 +153,8 @@ if (ENVIRONMENT_IS_NODE) {
 else if (ENVIRONMENT_IS_SHELL) {
   if (!Module['print']) Module['print'] = print;
   if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm
+  if (!Module['rawPrint']) Module['rawPrint'] = putstr;
+  //if (!Module['rawPrintErr']) Module['rawPrintErr'] = putstr; // goes to stdout not stderr.
 
   if (typeof read != 'undefined') {
     Module['read'] = function shell_read(f) {
diff --git a/src/shell_minimal.html b/src/shell_minimal.html
index c441444c5e5..662ab6033e3 100644
--- a/src/shell_minimal.html
+++ b/src/shell_minimal.html
@@ -101,6 +101,22 @@
             console.error(text);
           }
         },
+        rawPrint: function(text) {
+          var element = document.getElementById('output');
+          if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
+          if (text == "\n") {
+            text = "\r" + text;
+          }
+          element.value += text;
+        },
+        rawPrintErr: function(text) {
+          var element = document.getElementById('output');
+          if (arguments.length > 1) text = Array.prototype.slice.call(arguments).join(' ');
+          if (text == "\n") {
+            text = "\r" + text;
+          }
+          element.value += text;
+        },{{{ GET_CHAR }}}
         canvas: (function() {
           var canvas = document.getElementById('canvas');
 
diff --git a/system/lib/pthread/library_pthread.c b/system/lib/pthread/library_pthread.c
index 14cdf2f0c00..6b34a7d3eaf 100644
--- a/system/lib/pthread/library_pthread.c
+++ b/system/lib/pthread/library_pthread.c
@@ -185,7 +185,7 @@ void emscripten_async_waitable_close(em_queued_call *call)
 	em_queued_call_free(call);
 }
 
-static void _do_call(em_queued_call *q)
+static int _do_call(em_queued_call *q)
 {
 	switch(q->functionEnum)
 	{
@@ -202,6 +202,13 @@ static void _do_call(em_queued_call *q)
 		default: assert(0 && "Invalid Emscripten pthread _do_call opcode!");
 	}
 
+	if (q->functionEnum == EM_PROXIED_SYSCALL && q->args[0].i == 145
+	               && q->returnValue.i == -EAGAIN && isatty((*(int *)(q->args[1].vp)))) {
+		// We tried to do a read operation from the terminal, but no input was ready,
+		// so return without waking the worker.
+		return -1;
+	} 
+	
 	// If the caller is detached from this operation, it is the main thread's responsibility to free up the call object.
 	if (q->calleeDelete) {
 		emscripten_async_waitable_close(q);
@@ -211,6 +218,7 @@ static void _do_call(em_queued_call *q)
 		q->operationDone = 1;
 		emscripten_futex_wake(&q->operationDone, INT_MAX);
 	}
+	return 0;
 }
 
 #define CALL_QUEUE_SIZE 128
@@ -428,9 +436,13 @@ void EMSCRIPTEN_KEEPALIVE emscripten_main_thread_process_queued_calls()
 	{
 		// Assume that the call is heavy, so unlock access to the call queue while it is being performed.
 		pthread_mutex_unlock(&call_queue_lock);
-		_do_call(call_queue[head]);
+		int ret = _do_call(call_queue[head]);
 		pthread_mutex_lock(&call_queue_lock);
 
+		// If we get a return value of -1, leave the operation on the queue and return and we will
+		// restart processing later.
+		if (ret == -1) break;
+
 		head = (head + 1) % CALL_QUEUE_SIZE;
 		emscripten_atomic_store_u32((void*)&call_queue_head, head);
 		tail = emscripten_atomic_load_u32((void*)&call_queue_tail);
diff --git a/tests/module/test_stdin2.c b/tests/module/test_stdin2.c
new file mode 100644
index 00000000000..e97c609eac6
--- /dev/null
+++ b/tests/module/test_stdin2.c
@@ -0,0 +1,26 @@
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+
+int main(int argc, char const *argv[])
+{
+  char name[200], colour[200], answer[200];
+
+  while (1) {
+    printf("Enter your name: ");
+    fflush(stdout);
+    scanf("%s",name);
+    printf("Hello %s.\n", name);
+    printf("What is your favourite colour? ");
+    fflush(stdout);
+    scanf("%s",colour);
+    printf("%s is a great colour!\n", colour);
+    fprintf(stderr, "Do you want another go? ");
+    fflush(stderr);
+    scanf("%s", answer);
+    if (!strcmp(answer, "yes") || !strcmp(answer, "Yes") || !strcmp(answer, "YES")) continue;
+    break; 
+  }
+  printf("Goodbye, %s.\n", name);
+  exit(0);
+}
diff --git a/tests/test_other.py b/tests/test_other.py
index 5f6af4338d2..aed100472d4 100644
--- a/tests/test_other.py
+++ b/tests/test_other.py
@@ -1216,6 +1216,34 @@ def _test():
                   output_filename='a.out.js')
     _test()
 
+  def test_stdin2(self):
+    def _test():
+      for engine in JS_ENGINES:
+        if engine == V8_ENGINE: continue # no stdin support in v8 shell
+        engine[0] = os.path.normpath(engine[0])
+        print >> sys.stderr, engine
+        # work around a bug in python's subprocess module
+        # (we'd use run_js() normally)
+        try_delete('out.txt')
+        try_delete('err.txt')
+        if os.name == 'nt': # windows
+          os.system('type "in.txt" | {} >out.txt 2>err.txt'.format(' '.join(Building.doublequote_spaces(make_js_command(os.path.normpath(exe), engine)))))
+        else: # posix
+          os.system('cat in.txt | {} > out.txt 2>err.txt'.format(' '.join(Building.doublequote_spaces(make_js_command(exe, engine)))))
+        self.assertContained('''Enter your name: Hello Dave.
+What is your favourite colour? Green is a great colour!
+Goodbye, Dave.''', open('out.txt').read())
+        self.assertContained('Do you want another go?', open('err.txt').read())
+
+    Building.emcc(path_from_root('tests', 'module', 'test_stdin2.c'), output_filename='a.out.js')
+    open('in.txt', 'w').write('Dave\nGreen\nNo\n')
+    exe = os.path.join(self.get_dir(), 'a.out.js')
+    _test()
+    Building.emcc(path_from_root('tests', 'module', 'test_stdin2.c'),
+                  ['-O2', '--closure', '1'],
+                  output_filename='a.out.js')
+    _test()
+
   def test_ungetc_fscanf(self):
     open('main.cpp', 'w').write(r'''
       #include <stdio.h>
